from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, String, Float

Phylorank_Outliers_V0_1_0 = CommandToolBuilder(tool="phylorank_outliers", base_command=["phylorank", "outliers"], inputs=[ToolInput(tag="in_viral", input_type=Boolean(optional=True), prefix="--viral", doc=InputDocumentation(doc="indicates a viral input tree and taxonomy")), ToolInput(tag="in_fixed_root", input_type=Boolean(optional=True), prefix="--fixed_root", doc=InputDocumentation(doc="use single fixed root to infer outliers")), ToolInput(tag="in_trusted_tax_a_file", input_type=File(optional=True), prefix="--trusted_taxa_file", doc=InputDocumentation(doc="file indicating trusted taxonomic groups to use for\ninferring distribution (default: all taxa)")), ToolInput(tag="in_min_children", input_type=Int(optional=True), prefix="--min_children", doc=InputDocumentation(doc="minimum required child taxa to consider taxa when\ninferring distribution (default: 2)")), ToolInput(tag="in_min_support", input_type=Int(optional=True), prefix="--min_support", doc=InputDocumentation(doc="minimum support value to consider taxa when inferring\ndistribution (default: 0) (default: 0.0)")), ToolInput(tag="in_f_measure_table", input_type=String(optional=True), prefix="--fmeasure_table", doc=InputDocumentation(doc="table indicating F-measure score for each taxa")), ToolInput(tag="in_min_f_measure", input_type=Float(optional=True), prefix="--min_fmeasure", doc=InputDocumentation(doc="minimum F-measure to consider taxa when inferring\ndistribution (default: 0.95)")), ToolInput(tag="in_f_measure_mono", input_type=Float(optional=True), prefix="--fmeasure_mono", doc=InputDocumentation(doc="minimum F-measure to consider taxa monophyletic\n(default: 0.95)")), ToolInput(tag="in_highlight_poly_phyl_y", input_type=Boolean(optional=True), prefix="--highlight_polyphyly", doc=InputDocumentation(doc="highlight taxa with an F-measure less than\n--fmeasure_mono")), ToolInput(tag="in_mb_let", input_type=Boolean(optional=True), prefix="--mblet", doc=InputDocumentation(doc="calculate 'mean branch length to extent taxa' instead\nof 'relative evolutionary distances'")), ToolInput(tag="in_plot_tax_a_file", input_type=File(optional=True), prefix="--plot_taxa_file", doc=InputDocumentation(doc="file indicating taxonomic groups to plot (default: all\ntaxa)")), ToolInput(tag="in_plot_domain", input_type=Boolean(optional=True), prefix="--plot_domain", doc=InputDocumentation(doc="show domain rank in plot")), ToolInput(tag="in_plot_dist_tax_a_only", input_type=Boolean(optional=True), prefix="--plot_dist_taxa_only", doc=InputDocumentation(doc="only plot taxa used to infer distribution")), ToolInput(tag="in_highlight_tax_a_file", input_type=File(optional=True), prefix="--highlight_taxa_file", doc=InputDocumentation(doc="file indicating taxa to highlight")), ToolInput(tag="in_dpi", input_type=Int(optional=True), prefix="--dpi", doc=InputDocumentation(doc="DPI of plots (default: 96)")), ToolInput(tag="in_verbose_table", input_type=Boolean(optional=True), prefix="--verbose_table", doc=InputDocumentation(doc="add additional columns to output table")), ToolInput(tag="in_skip_m_pld_three", input_type=Boolean(optional=True), prefix="--skip_mpld3", doc=InputDocumentation(doc="skip plots requiring mpld3")), ToolInput(tag="in_input_tree", input_type=String(), position=0, doc=InputDocumentation(doc="decorated tree for inferring RED outliers")), ToolInput(tag="in_taxonomy_file", input_type=String(), position=1, doc=InputDocumentation(doc="taxonomy file for inferring RED outliers")), ToolInput(tag="in_output_dir", input_type=String(), position=2, doc=InputDocumentation(doc="desired output directory for generated files"))], outputs=[], container="quay.io/biocontainers/phylorank:0.1.9--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Phylorank_Outliers_V0_1_0().translate("wdl")

